/*
 * ValorCampoSegunFechaNacDependiente.java
 *
 * Created on 24 de marzo de 2007, 09:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;
import java.util.StringTokenizer;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

// 9,N07,8,D#E
/**
 * 
 * @author Julian
 */
public class ValorCampoSegunFechaNacDependiente extends AbstractRule {
	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	// Create object of SimpleDateFormat and pass the desired date format.
	public void setParams(Object[] params) {
		String valores = (String) params[3];
		ArrayList<String> listaString = new ArrayList<String>();
		StringTokenizer st = new StringTokenizer(valores, ",");
		while (st.hasMoreTokens()) {
			listaString.add(st.nextToken());
		}
		String[] array = listaString.toArray(new String[listaString.size()]);
		Arrays.sort(array);
		params[3] = array;
		super.setParams(params);
	}

	/** Creates a new instance of CampoVacio */
	public ValorCampoSegunFechaNacDependiente() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String codigoNovedad = registro[new Integer((String) getParams()[0])
				.intValue()];
		if (codigoNovedad.equals((String) getParams()[1])) {
			if (registro[new Integer((String) getParams()[4]).intValue()]
					.equals((String) getParams()[5])) {
				String FechaNacimiento = registro[new Integer(
						(String) getParams()[2]).intValue()];
				if (!ValidarFecha.esFecha(FechaNacimiento))
					return false;
				Date dateNacimiento = null;

				try {
					dateNacimiento = sdf.parse(FechaNacimiento);

				} catch (Exception e) {
					return false;
				}

				double annos = Math
						.floor(ObtenerDiasEntreFechas.calcular(dateNacimiento,
								Calendar.getInstance().getTime()) / 365);
				if (annos > 18) {
					return Arrays
							.binarySearch((String[]) getParams()[3], field) < 0;
				} else {
					if (field.length() > 0) {
						return true;
					}

				}
			}
		}
		return false;
	}

}
